diff -Naur WindowMaker-0.92.0-orig/src/dock.c WindowMaker-0.92.0/src/dock.c
--- WindowMaker-0.92.0-orig/src/dock.c	2007-01-10 23:36:31.000000000 +0100
+++ WindowMaker-0.92.0/src/dock.c	2007-01-10 23:45:03.000000000 +0100
@@ -4474,3 +4549,677 @@
     return status;
 }
 
+
+static void
+drawerAppendToChain(WScreen *scr, WDock *drawer)
+{
+    WDrawerChain **where_to_add;
+
+    where_to_add = &scr->drawers;
+    while ((*where_to_add) != NULL) {
+        where_to_add = &(*where_to_add)->next;
+    }
+
+    *where_to_add = wmalloc(sizeof(WDrawerChain));
+    (*where_to_add)->adrawer = drawer;
+    (*where_to_add)->next = NULL;
+    scr->drawer_count++;
+}
+
+
+static void
+drawerRemoveFromChain(WScreen *scr, WDock *drawer)
+{
+    WDrawerChain *next, **to_remove;
+
+    to_remove = &scr->drawers;
+    while (True) {
+        if (*to_remove == NULL) {
+            wwarning("The drawer to be removed can not be found.");
+            return;
+        }
+        if ((*to_remove)->adrawer == drawer)
+            break;
+
+        to_remove = &(*to_remove)->next;
+    }
+    next = (*to_remove)->next;
+    wfree(*to_remove);
+    *to_remove = next;
+    scr->drawer_count--;
+}
+
+
+/* Don't free the returned string. Duplicate it. */
+static char *
+findUniqueName(WScreen *scr, char *instance_basename)
+{
+    static char buffer[128];
+    WDrawerChain *dc;
+    int i;
+    int already_in_use = True;
+
+#define UNIQUE_NAME_WATCHDOG 128
+    for (i = 0; already_in_use && i < UNIQUE_NAME_WATCHDOG; i++) {
+        snprintf(buffer, sizeof buffer, "%s%d", instance_basename, i);
+
+        already_in_use = False;
+
+        for (dc = scr->drawers; dc != NULL; dc = dc->next) {
+            if (!strncmp(dc->adrawer->icon_array[0]->wm_instance, buffer,
+                         sizeof buffer)) {
+                already_in_use = True;
+                break;
+            }
+        }
+    }
+
+    if (i == UNIQUE_NAME_WATCHDOG)
+        wwarning("Couldn't find a unique name for drawer in %d attemps.", i);
+#undef UNIQUE_NAME_WATCHDOG
+
+    return buffer;
+}
+
+
+static void
+drawerIconExpose(WObjDescriptor *desc, XEvent *event)
+{
+    wDrawerIconPaint((WAppIcon *) desc->parent);
+}
+
+
+static int
+addADrawer(WScreen *scr)
+{
+    int i, y;
+    WDock *drawer, *dock = scr->dock;
+    WDrawerChain *dc;
+    char can_be_here[dock->max_icons];
+
+    if (dock->icon_count + scr->drawer_count >= dock->max_icons)
+        return -1;
+
+    for (y = 0; y < dock->max_icons; y++) {
+        can_be_here[ y ] = True;
+    }
+    for (i = 0; i < dock->max_icons; i++) {
+        if (dock->icon_array[ i ] != NULL)
+            can_be_here[ dock->icon_array[i]->yindex ] = False;
+    }
+    for (dc = scr->drawers; dc != NULL; dc = dc->next) {
+        y = (int) ((dc->adrawer->y_pos - dock->y_pos) / ICON_SIZE);
+        can_be_here[ y ] = False;
+    }
+
+    for (y = 0; y < dock->max_icons; y++) {
+        if (can_be_here[ y ])
+            break;
+    }
+
+    drawer = wDockCreate(scr, WM_DRAWER, NULL);
+
+    drawer->x_pos = dock->x_pos;
+    drawer->y_pos = dock->y_pos + ICON_SIZE * y;
+    drawer->icon_array[0]->xindex = 0;
+    drawer->icon_array[0]->yindex = 0;
+    drawer->icon_array[0]->x_pos = drawer->x_pos;
+    drawer->icon_array[0]->y_pos = drawer->y_pos;
+    XMoveWindow(dpy, drawer->icon_array[0]->icon->core->window,
+                drawer->icon_array[0]->x_pos, drawer->icon_array[0]->y_pos = drawer->y_pos);
+
+    return 0;
+}
+
+
+static void
+addADrawerCallback(WMenu *menu, WMenuEntry *entry)
+{
+    assert(entry->clientdata!=NULL);
+    addADrawer(((WAppIcon *) entry->clientdata)->dock->screen_ptr);
+}
+
+
+static void
+drawerDestroy(WDock *drawer)
+{
+    WScreen *scr;
+    int i;
+    WAppIcon *aicon;
+    WMArray *icons;
+
+    if (drawer == NULL)
+        return;
+
+    scr = drawer->screen_ptr;
+
+#if 0 /* Actually, we can't delete any dock/clip/drawer menu, because
+       * that would (try to) wfree some memory in gettext library (see
+       * menu entries that have several "versions", such like "Hide"
+       * and "Unhide"). */
+    if (scr->drawer_count == 1) { /* last drawer */
+        wMenuDestroy(drawer->menu, False);
+        scr->drawer_menu = NULL;
+    }
+#endif
+    wDefaultPurgeInfo(scr, drawer->icon_array[0]->wm_instance,
+                      drawer->icon_array[0]->wm_class);
+    icons = WMCreateArray(drawer->icon_count - 1);
+    for (i = 1; i < drawer->max_icons; i++) {
+        if (!(aicon = drawer->icon_array[ i ]))
+            continue;
+        WMAddToArray(icons, aicon);
+    }
+    removeIcons(icons, drawer);
+
+    if (drawer->auto_collapse_magic) {
+        WMDeleteTimerHandler(drawer->auto_collapse_magic);
+        drawer->auto_collapse_magic = NULL;
+    }
+    if (drawer->auto_lower_magic) {
+        WMDeleteTimerHandler(drawer->auto_lower_magic);
+        drawer->auto_lower_magic = NULL;
+    }
+
+    wAppIconDestroy(drawer->icon_array[0]);
+    wfree(drawer->icon_array);
+    wfree(drawer);
+
+    drawerRemoveFromChain(scr, drawer);
+    if (scr->last_dock == drawer)
+        scr->last_dock = NULL;
+    if (scr->attracting_drawer == drawer)
+        scr->attracting_drawer = NULL;
+}
+
+
+static void
+removeDrawerCallback(WMenu *menu, WMenuEntry *entry)
+{
+    WDock *dock = ((WAppIcon*)entry->clientdata)->dock;
+    assert(dock != NULL);
+
+    if (dock->icon_count > 1) {
+        if (wMessageDialog(dock->screen_ptr, _("Drawer"),
+                           _("All icons in this drawer will be detached!"),
+                           _("OK"), _("Cancel"), NULL)!=WAPRDefault)
+            return;
+    }
+    drawerDestroy(dock);
+}
+
+
+void
+wDrawerIconPaint(WAppIcon *dicon)
+{
+    Window win = dicon->icon->core->window;
+    WScreen *scr = dicon->icon->core->screen_ptr;
+    XPoint p[4];
+    GC gc = scr->draw_gc;
+    WMColor *color;
+
+    wIconPaint(dicon->icon);
+
+    if (!dicon->dock->collapsed)
+        color = scr->clip_title_color[CLIP_NORMAL];
+    else
+        color = scr->clip_title_color[CLIP_COLLAPSED];
+    XSetForeground(dpy, gc, WMColorPixel(color));
+
+    if (dicon->dock->on_right_side) {
+        p[0].x = p[3].x = 10;
+        p[0].y = p[3].y = ICON_SIZE / 2 - 5;
+        p[1].x = 10;
+        p[1].y = ICON_SIZE / 2 + 5;
+        p[2].x = 5;
+        p[2].y = ICON_SIZE / 2;
+    } else {
+        p[0].x = p[3].x = ICON_SIZE-1 - 10;
+        p[0].y = p[3].y = ICON_SIZE / 2 - 5;
+        p[1].x = ICON_SIZE-1 - 10;
+        p[1].y = ICON_SIZE / 2 + 5;
+        p[2].x = ICON_SIZE-1 - 5;
+        p[2].y = ICON_SIZE / 2;
+    }
+    XFillPolygon(dpy, win, gc, p,3,Convex,CoordModeOrigin);
+    XDrawLines(dpy, win, gc, p,4,CoordModeOrigin);
+}
+
+
+RImage*
+wDrawerMakeTile(WScreen *scr, RImage *normalTile)
+{
+    RImage *tile = RCloneImage(normalTile);
+    RColor dark;
+    RColor light;
+
+    dark.alpha = 0;
+    dark.red = dark.green = dark.blue = 60;
+
+    light.alpha = 0;
+    light.red = light.green = light.blue = 80;
+
+    /* arrow bevel */
+    if (!scr->dock || scr->dock->on_right_side)
+    {
+        ROperateLine(tile, RSubtractOperation, 11, ICON_SIZE / 2 - 7,
+                     4, ICON_SIZE / 2, &dark);       /* / */
+        ROperateLine(tile, RSubtractOperation, 11, ICON_SIZE / 2 + 7,
+                     4, ICON_SIZE / 2, &dark);       /* \ */
+        ROperateLine(tile, RAddOperation,      11, ICON_SIZE / 2 - 7,
+                     11, ICON_SIZE / 2 + 7, &light); /* | */
+    }
+    else
+    {
+        ROperateLine(tile, RSubtractOperation, ICON_SIZE-1 - 11, ICON_SIZE / 2 - 7,
+                     ICON_SIZE-1 - 4, ICON_SIZE / 2, &dark);      /* \ */
+        ROperateLine(tile, RAddOperation,      ICON_SIZE-1 - 11, ICON_SIZE / 2 + 7,
+                     ICON_SIZE-1 - 4, ICON_SIZE / 2, &light);     /* / */
+        ROperateLine(tile, RSubtractOperation, ICON_SIZE-1 - 11, ICON_SIZE / 2 - 7,
+                     ICON_SIZE-1 - 11, ICON_SIZE / 2 + 7, &dark); /* | */
+    }
+    return tile;
+}
+
+
+static void
+swapDrawer(WDock *drawer, int new_x)
+{
+    int i;
+
+    drawer->on_right_side = !drawer->on_right_side;
+    drawer->x_pos = new_x;
+
+    for (i = 0; i < drawer->max_icons; i++) {
+        WAppIcon *ai;
+        if ((ai = drawer->icon_array[ i ]) == NULL)
+            continue;
+        ai->xindex *= -1; /* so A B C becomes C B A */
+        ai->x_pos = new_x + ai->xindex * ICON_SIZE;
+
+        /* Update drawer's tile */
+        if (i == 0) {
+            wIconUpdate(ai->icon);
+            wDrawerIconPaint(ai);
+        }
+        XMoveWindow(dpy, ai->icon->core->window, ai->x_pos, ai->y_pos);
+    }
+}
+
+
+static void
+swapDrawers(WScreen *scr, int on_right_side, int new_x)
+{
+    WDrawerChain *dc;
+
+    if (scr->drawer_tile) {
+        RReleaseImage(scr->drawer_tile);
+    }
+    scr->drawer_tile = wDrawerMakeTile(scr, scr->icon_tile);
+
+    for (dc = scr->drawers; dc != NULL; dc = dc->next) {
+        swapDrawer(dc->adrawer, new_x);
+        assert(dc->adrawer->on_right_side == on_right_side);
+    }
+}
+
+
+static int
+isADrawer(WScreen *scr, WAppIcon *aicon)
+{
+    return aicon && aicon->dock &&
+        aicon->dock->type == WM_DRAWER && aicon->dock->icon_array[ 0 ] == aicon;
+}
+
+
+static WDock*
+getDrawer(WScreen *scr, int y_index)
+{
+    WDrawerChain *dc;
+
+    for (dc = scr->drawers; dc != NULL; dc = dc->next) {
+        if (dc->adrawer->y_pos - scr->dock->y_pos == y_index * ICON_SIZE)
+            return dc->adrawer;
+    }
+    return NULL;
+}
+
+
+
+/* Find the "hole" a moving appicon created when snapped into the
+ * drawer. redocking is a boolean. If the moving appicon comes from the
+ * drawer, drawer->icon_count is correct. If not, redocking is then false and
+ * there are now drawer->icon_count plus one appicons in the drawer. */
+static int
+indexOfHole(WDock *drawer, WAppIcon *moving_aicon, int redocking)
+{
+    int index_of_hole, i;
+
+    /* /!\ That 's a (pretty clever) kludge. ;-)
+     *
+     * We have n-1 (n = drawer->icon_count-1 or drawer->icon_count, see
+     * redocking) appicons, whose xindex are unique in [1..n]. One is missing:
+     * that's where the ghost of the moving appicon is, that's what the
+     * function should return.
+     *
+     * We compute 1+2+...+n (this sum is equal to n*(n+1)/2), we substract to
+     * this sum the xindex of each of the n-1 appicons, and we get the correct
+     * index ! */
+
+    if (redocking) {
+        index_of_hole = (drawer->icon_count-1) * drawer->icon_count / 2;
+    } else {
+        index_of_hole = drawer->icon_count * (drawer->icon_count+1) / 2;
+    }
+    index_of_hole *= (drawer->on_right_side ? -1 : 1);
+
+    for (i = 1; i < drawer->max_icons; i++) {
+        if (drawer->icon_array[i] && drawer->icon_array[i] != moving_aicon)
+            index_of_hole -= drawer->icon_array[ i ]->xindex;
+    }
+    /* wmessage(" Index of the moving appicon is %d (%sredocking)", index_of_hole, (redocking ? "" : "not ")); */
+    if (abs(index_of_hole) > abs(drawer->icon_count) - (redocking?1:0))
+        wwarning(" index_of_hole is too large ! (%d greater than %d)",
+                 index_of_hole, abs(drawer->icon_count) - (redocking?1:0));
+    if (index_of_hole == 0)
+        wwarning(" index_of_hole == 0 (%sredocking, icon_count == %d)", (redocking ? "" : "not "), drawer->icon_count);
+
+    return index_of_hole;
+}
+
+
+void
+wSlideAppicons(WAppIcon **appicons, int n, int to_the_left)
+{
+    int i;
+    int leftmost, min_index = 9999, from_x;
+    Window *wins[n]; /* to be "cleaned" ;-) */
+    WAppIcon *aicon;
+
+    if (n < 1)
+        return;
+
+    for (i = 0; i < n; i++) {
+        aicon = appicons[ i ];
+        aicon->xindex += (to_the_left ? -1 : +1);
+        if (aicon->xindex < min_index) {
+            min_index = aicon->xindex;
+            leftmost = i;
+            from_x = aicon->x_pos;
+        }
+        aicon->x_pos += (to_the_left ? -ICON_SIZE : +ICON_SIZE);
+    }
+
+    for (i = 0; i < n; i++) {
+        aicon = appicons[ i ];
+        wins[aicon->xindex - min_index] = &aicon->icon->core->window;
+    }
+    aicon = appicons[ leftmost ];
+    SlideWindows(wins, n, from_x, aicon->y_pos, aicon->x_pos, aicon->y_pos);
+}
+
+
+void
+wDrawerFillTheGap(WDock *drawer, WAppIcon *aicon, Bool redocking)
+{
+    int i, j;
+    int index_of_hole = indexOfHole(drawer, aicon, redocking);
+    WAppIcon *aicons_to_shift[ drawer->icon_count ]; /* to be "cleaned" ;-) */
+
+    j = 0;
+    for (i = 0; i < drawer->max_icons; i++) {
+        WAppIcon *ai = drawer->icon_array[ i ];
+        if (ai && ai != aicon &&
+            abs(ai->xindex) > abs(index_of_hole))
+            aicons_to_shift[ j++ ] = ai;
+    }
+    if (j != drawer->icon_count - abs(index_of_hole) - (redocking ? 1 : 0))
+        wwarning("Removing aicon at index %d from %s: j=%d but should be %d",
+                 index_of_hole, drawer->icon_array[0]->wm_instance,
+                 j, drawer->icon_count - abs(index_of_hole) - (redocking ? 1 : 0));
+    wSlideAppicons(aicons_to_shift, j, !drawer->on_right_side);
+}
+
+
+/* similar to wDockRestoreState, but a lot a specific stuff too... */
+static WDock *
+drawerRestoreState(WScreen *scr, WMPropList *drawer_state)
+{
+    WDock *drawer;
+    WMPropList *apps, *value, *dock_state;
+    WAppIcon *aicon, *old_top;
+    int count, i;
+
+    if (!drawer_state)
+        return NULL;
+
+    make_keys();
+
+    WMRetainPropList(drawer_state);
+
+    /* Get the instance name, and create a drawer */
+    value = WMGetFromPLDictionary(drawer_state, dName);
+    drawer = wDockCreate(scr, WM_DRAWER, WMGetFromPLString(value));
+
+    /* restore DnD command and paste command */
+#ifdef XDND
+    value = WMGetFromPLDictionary(drawer_state, dDropCommand);
+    if (value && WMIsPLString(value))
+	drawer->icon_array[0]->dnd_command = wstrdup(WMGetFromPLString(value));
+#endif /* XDND */
+
+    value = WMGetFromPLDictionary(drawer_state, dPasteCommand);
+    if (value && WMIsPLString(value))
+	drawer->icon_array[0]->paste_command = wstrdup(WMGetFromPLString(value));
+
+    /* restore position */
+    value = WMGetFromPLDictionary(drawer_state, dPosition);
+    if (!value || !WMIsPLString(value))
+        COMPLAIN("Position");
+    else {
+        int x, y, y_index;
+        if (sscanf(WMGetFromPLString(value), "%i,%i", &x, &y) != 2)
+            COMPLAIN("Position");
+
+        /* check position sanity */
+        if (x != scr->dock->x_pos) {
+            x = scr->dock->x_pos;
+        }
+        y_index = (y - scr->dock->y_pos) / ICON_SIZE;
+        if (y_index <= 0) {
+            y_index = 1;
+        }
+        if (y_index >= scr->dock->max_icons) {
+            /* Here we should do something more intelligent, since it
+             * can happen even if the user hasn't hand-edited his
+             * G/D/State file (but uses a lower resolution). */
+            y_index = scr->dock->max_icons - 1;
+        }
+        y = scr->dock->y_pos + y_index * ICON_SIZE;
+        moveDock(drawer, x, y);
+    }
+
+    /* restore dock properties (applist and others) */
+    dock_state = WMGetFromPLDictionary(drawer_state, dDock);
+
+    /* restore lowered/raised state */
+    drawer->lowered = 0;
+    value = WMGetFromPLDictionary(dock_state, dLowered);
+    if (value && strcasecmp(WMGetFromPLString(value), "YES") ==0) {
+        drawer->lowered = 1;
+    }
+    if (!drawer->lowered || !scr->dock->lowered)
+        ChangeStackingLevel(drawer->icon_array[ 0 ]->icon->core, WMDockLevel);
+    else
+        ChangeStackingLevel(drawer->icon_array[ 0 ]->icon->core, WMNormalLevel);
+    wRaiseFrame(drawer->icon_array[ 0 ]->icon->core);
+
+    /* restore collapsed state */
+    drawer->collapsed = 0;
+    value = WMGetFromPLDictionary(dock_state, dCollapsed);
+    if (value && strcasecmp(WMGetFromPLString(value), "YES") ==0) {
+        drawer->collapsed = 1;
+    }
+    /* restore auto-collapsed state */
+    value = WMGetFromPLDictionary(dock_state, dAutoCollapse);
+    if (value && strcasecmp(WMGetFromPLString(value), "YES") ==0) {
+        drawer->auto_collapse = 1;
+        drawer->collapsed = 1;
+    }
+    /* restore auto-raise/lower state */
+    value = WMGetFromPLDictionary(dock_state, dAutoRaiseLower);
+    if (value && strcasecmp(WMGetFromPLString(value), "YES") ==0) {
+        drawer->auto_raise_lower = 1;
+    }
+    /* restore attract icons state */
+    drawer->attract_icons = 0;
+    value = WMGetFromPLDictionary(dock_state, dAutoAttractIcons);
+    if (value && strcasecmp(WMGetFromPLString(value), "YES") ==0) {
+        drawer->attract_icons = 1;
+        scr->attracting_drawer = drawer;
+    }
+
+    /* application list */
+    apps = WMGetFromPLDictionary(dock_state, dApplications);
+
+    if (!apps) {
+        goto finish;
+    }
+
+    count = WMGetPropListItemCount(apps);
+
+    if (count==0)
+        goto finish;
+
+    old_top = drawer->icon_array[0];
+
+    for (i=0; i<count; i++) {
+        if (drawer->icon_count >= drawer->max_icons) {
+            wwarning(_("there are too many icons stored in drawer. Ignoring what doesn't fit"));
+            break;
+        }
+
+        value = WMGetFromPLArray(apps, i);
+        aicon = restore_icon_state(scr, value, WM_DRAWER, drawer->icon_count);
+
+        drawer->icon_array[drawer->icon_count] = aicon;
+
+        if (aicon) {
+            aicon->dock = drawer;
+            aicon->x_pos = drawer->x_pos + (aicon->xindex*ICON_SIZE);
+            aicon->y_pos = drawer->y_pos + (aicon->yindex*ICON_SIZE);
+
+            if (!drawer->lowered)
+                ChangeStackingLevel(aicon->icon->core, WMDockLevel);
+            else
+                ChangeStackingLevel(aicon->icon->core, WMNormalLevel);
+
+            wCoreConfigure(aicon->icon->core, aicon->x_pos, aicon->y_pos,
+                           0, 0);
+
+            if (!drawer->collapsed)
+                XMapWindow(dpy, aicon->icon->core->window);
+            wRaiseFrame(aicon->icon->core);
+
+            drawer->icon_count++;
+        }
+    }
+
+finish:
+    WMReleasePropList(drawer_state);
+
+    return drawer;
+}
+
+
+/* Same kind of comment than for previous function: this function is
+ * very similar to make_icon_state, but has substential differences as
+ * well. */
+static WMPropList *
+drawerSaveState(WScreen *scr, WDock *drawer)
+{
+    WMPropList *pstr, *drawer_state;
+    WAppIcon *ai;
+    char buffer[ 64 ];
+
+    ai = drawer->icon_array[ 0 ];
+    /* Store its name */
+    pstr = WMCreatePLString(ai->wm_instance);
+    drawer_state = WMCreatePLDictionary(dName, pstr, NULL); /* we need this final NULL */
+    WMReleasePropList(pstr);
+
+    /* Store its position */
+    snprintf(buffer, sizeof(buffer), "%hi,%hi", ai->x_pos, ai->y_pos);
+    pstr = WMCreatePLString(buffer);
+    WMPutInPLDictionary(drawer_state, dPosition, pstr);
+    WMReleasePropList(pstr);
+
+#ifdef XDND
+    /* Store its DnD command */
+    if (ai->dnd_command) {
+        pstr = WMCreatePLString(ai->dnd_command);
+        WMPutInPLDictionary(drawer_state, dDropCommand, pstr);
+        WMReleasePropList(pstr);
+    }
+#endif /* XDND */
+
+    /* Store its paste command */
+    if (ai->paste_command) {
+        pstr = WMCreatePLString(ai->paste_command);
+        WMPutInPLDictionary(drawer_state, dPasteCommand, pstr);
+        WMReleasePropList(pstr);
+    }
+
+    /* Store applications list and other properties */
+    pstr = dockSaveState(drawer);
+    WMPutInPLDictionary(drawer_state, dDock, pstr);
+    WMReleasePropList(pstr);
+
+    return drawer_state;
+}
+
+
+void
+wDrawersSaveState(WScreen *scr, WMPropList *old_state)
+{
+    WMPropList *all_drawers, *drawer_state;
+    int i;
+    WDrawerChain *dc;
+
+    make_keys();
+
+    all_drawers = WMCreatePLArray(NULL);
+    for (i=0, dc = scr->drawers;
+         i < scr->drawer_count;
+         i++, dc = dc->next) {
+        drawer_state = drawerSaveState(scr, dc->adrawer);
+        WMAddToPLArray(all_drawers, drawer_state);
+        WMReleasePropList(drawer_state);
+    }
+    WMPutInPLDictionary(scr->session_state, dDrawers, all_drawers);
+    WMReleasePropList(all_drawers);
+}
+
+
+void
+wDrawersRestoreState(WScreen *scr)
+{
+    WMPropList *all_drawers, *drawer_state;
+    int i;
+    WDrawerChain **dc;
+
+    make_keys();
+
+    if (scr->session_state == NULL)
+        return;
+
+    all_drawers = WMGetFromPLDictionary(scr->session_state, dDrawers);
+    if (!all_drawers)
+        return;
+
+    dc = &scr->drawers;
+    for (i = 0; i < WMGetPropListItemCount(all_drawers); i++) {
+        drawer_state = WMGetFromPLArray(all_drawers, i);
+        drawerRestoreState(scr, drawer_state);
+    }
+}
diff -Naur WindowMaker-0.92.0-orig/src/dock.h WindowMaker-0.92.0/src/dock.h
--- WindowMaker-0.92.0-orig/src/dock.h	2004-10-14 19:31:49.000000000 +0200
+++ WindowMaker-0.92.0/src/dock.h	2007-01-10 23:45:03.000000000 +0100
@@ -40,6 +40,7 @@
 
 #define WM_DOCK        0
 #define WM_CLIP        1
+#define WM_DRAWER      2
 #define NORMAL_DOCK    WM_DOCK
 #define EXTENDED_DOCK  WM_CLIP
     int type;
@@ -69,7 +70,7 @@
 
 
 
-WDock *wDockCreate(WScreen *scr, int type);
+WDock *wDockCreate(WScreen *scr, int type, char *name);
 WDock *wDockRestoreState(WScreen *scr, WMPropList *dock_state, int type);
 
 void wDockDestroy(WDock *dock);
@@ -81,10 +82,15 @@
 void wDockSaveState(WScreen *scr, WMPropList *old_state);
 
 Bool wDockAttachIcon(WDock *dock, WAppIcon *icon, int x, int y);
+void wDockReattachIcon(WDock *dock, WAppIcon *icon, int x, int y);
 Bool wDockSnapIcon(WDock *dock, WAppIcon *icon, int req_x, int req_y,
                    int *ret_x, int *ret_y, int redocking);
 Bool wDockFindFreeSlot(WDock *dock, int *req_x, int *req_y);
 void wDockDetach(WDock *dock, WAppIcon *icon);
+Bool wDockMoveIconBetweenDocks(WDock *src, WDock *dest, WAppIcon *icon, int x, int y);
+
+void wSlideAppicons(WAppIcon **appicons, int n, int to_the_left);
+void wDrawerFillTheGap(WDock *drawer, WAppIcon *aicon, Bool redocking);
 
 void wDockFinishLaunch(WDock *dock, WAppIcon *icon);
 void wDockTrackWindowLaunch(WDock *dock, Window window);
@@ -101,9 +107,14 @@
 WMPropList *wClipSaveWorkspaceState(WScreen *scr, int workspace);
 WAppIcon *wClipRestoreState(WScreen *scr, WMPropList *clip_state);
 
+void wDrawerIconPaint(WAppIcon *dicon);
+void wDrawersSaveState(WScreen *scr, WMPropList *old_state);
+void wDrawersRestoreState(WScreen *scr);
+
 void wClipUpdateForWorkspaceChange(WScreen *scr, int workspace);
 
 RImage *wClipMakeTile(WScreen *scr, RImage *normalTile);
+RImage* wDrawerMakeTile(WScreen *scr, RImage *normalTile);
 
 #define WO_FAILED          0
 #define WO_NOT_APPLICABLE  1
diff -Naur WindowMaker-0.92.0-orig/src/funcs.h WindowMaker-0.92.0/src/funcs.h
--- WindowMaker-0.92.0-orig/src/funcs.h	2004-10-14 20:03:28.000000000 +0200
+++ WindowMaker-0.92.0/src/funcs.h	2007-01-10 23:45:03.000000000 +0100
@@ -113,6 +113,7 @@
 WWindow *NextToFocusBefore(WWindow *wwin);
 
 void SlideWindow(Window win, int from_x, int from_y, int to_x, int to_y);
+void SlideWindows(Window *wins[], int n, int from_x, int from_y, int to_x, int to_y);
 
 char *ShrinkString(WMFont *font, char *string, int width);
 
diff -Naur WindowMaker-0.92.0-orig/src/icon.c WindowMaker-0.92.0/src/icon.c
--- WindowMaker-0.92.0-orig/src/icon.c	2005-03-11 23:27:58.000000000 +0100
+++ WindowMaker-0.92.0/src/icon.c	2007-01-10 23:45:03.000000000 +0100
@@ -320,11 +320,20 @@
     unsigned w, h;
     int theight = WMFontHeight(scr->icon_title_font);
 
-    if (tileType == TILE_NORMAL)
-        tile = RCloneImage(scr->icon_tile);
-    else {
-        assert(scr->clip_tile);
-        tile = RCloneImage(scr->clip_tile);
+    switch (tileType) {
+    default:
+        wwarning("Unknown tileType: %d.\n", tileType);
+    case TILE_NORMAL:
+	tile = RCloneImage(scr->icon_tile);
+        break;
+    case TILE_CLIP:
+	assert(scr->clip_tile);
+	tile = RCloneImage(scr->clip_tile);
+        break;
+    case TILE_DRAWER:
+	assert(scr->drawer_tile);
+	tile = RCloneImage(scr->drawer_tile);
+        break;
     }
     if (icon) {
         w = (icon->width > wPreferences.icon_size)
diff -Naur WindowMaker-0.92.0-orig/src/icon.h WindowMaker-0.92.0/src/icon.h
--- WindowMaker-0.92.0-orig/src/icon.h	2004-10-12 19:55:34.000000000 +0200
+++ WindowMaker-0.92.0/src/icon.h	2007-01-10 23:45:03.000000000 +0100
@@ -30,6 +30,7 @@
 
 #define TILE_NORMAL	0
 #define TILE_CLIP	1
+#define TILE_DRAWER     2
 
 
 typedef struct WIcon {
diff -Naur WindowMaker-0.92.0-orig/src/misc.c WindowMaker-0.92.0/src/misc.c
--- WindowMaker-0.92.0-orig/src/misc.c	2004-11-11 14:31:47.000000000 +0100
+++ WindowMaker-0.92.0/src/misc.c	2007-01-10 23:45:03.000000000 +0100
@@ -53,6 +53,7 @@
 /**** global variables *****/
 
 extern WPreferences wPreferences;
+#define ICON_SIZE wPreferences.icon_size
 
 extern Time LastTimestamp;
 
@@ -330,9 +331,20 @@
 void
 SlideWindow(Window win, int from_x, int from_y, int to_x, int to_y)
 {
+    Window *wins[1] = { &win };
+    SlideWindows(wins, 1, from_x, from_y, to_x, to_y);
+}
+
+/* wins is an array of Window, sorted from left to right, the first is
+ * going to be moved from (from_x,from_y) to (to_x,to_y) and the
+ * following windows are going to be offset by (ICON_SIZE*i,0) */
+void
+SlideWindows(Window *wins[], int n, int from_x, int from_y, int to_x, int to_y)
+{
     time_t time0 = time(NULL);
     float dx, dy, x=from_x, y=from_y, sx, sy, px, py;
     int dx_is_bigger=0;
+    int i;
 
     /* animation parameters */
     static struct {
@@ -397,7 +409,9 @@
             px = (sy == 0 ? 0 : py*dx/dy);
         }
 
-        XMoveWindow(dpy, win, (int)x, (int)y);
+        for (i = 0; i < n; i++) {
+            XMoveWindow(dpy, *wins[i], (int)x + i * ICON_SIZE, (int)y);
+        }
         XFlush(dpy);
         if (apars[(int)wPreferences.icon_slide_speed].delay > 0) {
             wusleep(apars[(int)wPreferences.icon_slide_speed].delay*1000L);
@@ -407,7 +421,9 @@
         if (time(NULL) - time0 > MAX_ANIMATION_TIME)
             break;
     }
-    XMoveWindow(dpy, win, to_x, to_y);
+    for (i = 0; i < n; i++) {
+        XMoveWindow(dpy, *wins[i], to_x + i * ICON_SIZE, to_y);
+    }
 
     XSync(dpy, 0);
     /* compress expose events */
diff -Naur WindowMaker-0.92.0-orig/src/screen.c WindowMaker-0.92.0/src/screen.c
--- WindowMaker-0.92.0-orig/src/screen.c	2005-07-03 02:41:30.000000000 +0200
+++ WindowMaker-0.92.0/src/screen.c	2007-01-10 23:45:03.000000000 +0100
@@ -1069,6 +1069,8 @@
         scr->clip_icon = wClipRestoreState(scr, state);
     }
 
+    wDrawersRestoreState(scr);
+
     wWorkspaceRestoreState(scr);
 
     wScreenUpdateUsableArea(scr);
@@ -1118,6 +1120,7 @@
     }
 
     wWorkspaceSaveState(scr, old_state);
+    wDrawersSaveState(scr, old_state);
 
     if (wPreferences.save_session_on_exit) {
         wSessionSaveState(scr);
diff -Naur WindowMaker-0.92.0-orig/src/screen.h WindowMaker-0.92.0/src/screen.h
--- WindowMaker-0.92.0-orig/src/screen.h	2004-10-23 01:58:59.000000000 +0200
+++ WindowMaker-0.92.0/src/screen.h	2007-01-10 23:45:03.000000000 +0100
@@ -61,6 +61,14 @@
 } WAppIconChain;
 
 
+/* Drawers, which are Docks, really */
+
+typedef struct WDrawerChain {
+    struct WDock *adrawer;
+    struct WDrawerChain *next;
+} WDrawerChain;
+
+
 /*
  * each WScreen is saved into a context associated with it's root window
  */
@@ -233,9 +241,13 @@
     struct WMenu *clip_submenu;        /* Workspace list for clips */
     struct WMenu *clip_options;	       /* Options for Clip */
     struct WMenu *clip_ws_menu;	       /* workspace menu for clip */
+    struct WMenu *drawer_menu;         /* Menu for drawers */
     struct WDock *last_dock;
     WAppIconChain *global_icons;       /* for omnipresent icons chain in clip */
     int global_icon_count;	       /* How many global icons do we have */
+    WDrawerChain *drawers;             /* Chain of drawers */
+    int drawer_count;                  /* Nb of drawers */
+    struct WDock *attracting_drawer;   /* The drawer that auto attracts icons */
 
     Window clip_balloon;	       /* window for workspace name */
 
@@ -251,6 +263,7 @@
 
     struct RImage *icon_tile;
     struct RImage *clip_tile;
+    struct RImage *drawer_tile;        /* tile for a drawer (tile + arrow) */
     Pixmap icon_tile_pixmap;	       /* for app supplied icons */
 
     Pixmap def_icon_pixmap;	       /* default icons */
diff -Naur WindowMaker-0.92.0-orig/src/startup.c WindowMaker-0.92.0/src/startup.c
--- WindowMaker-0.92.0-orig/src/startup.c	2007-01-10 23:37:35.000000000 +0100
+++ WindowMaker-0.92.0/src/startup.c	2007-01-10 23:45:03.000000000 +0100
@@ -876,7 +876,15 @@
                     }
                 }
             }
-        }
+            /* auto-launch apps in drawers */
+            {
+                WDrawerChain *dc;
+                for (dc = wScreen[j]->drawers; dc; dc = dc->next) {
+                    wScreen[j]->last_dock = dc->adrawer;
+                    wDockDoAutoLaunch(dc->adrawer, 0);
+                }
+            }
+       }
 
         /* go to workspace where we were before restart */
         if (lastDesktop >= 0) {
